/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package vip.xiaonuo.disk.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollStreamUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import vip.xiaonuo.auth.core.util.StpLoginUserUtil;
import vip.xiaonuo.common.exception.CommonException;
import vip.xiaonuo.common.page.CommonPageRequest;
import vip.xiaonuo.disk.domain.UserComment;
import vip.xiaonuo.disk.mapper.UserCommentMapper;
import vip.xiaonuo.disk.param.UserCommentAddParam;
import vip.xiaonuo.disk.param.UserCommentEditParam;
import vip.xiaonuo.disk.param.UserCommentIdParam;
import vip.xiaonuo.disk.param.UserCommentPageParam;
import vip.xiaonuo.disk.service.UserCommentService;
import vip.xiaonuo.disk.vo.comment.UserCommentVo;

import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

/**
 * user_commentService接口实现类
 *
 * @author pans
 * @date  2025/06/27 11:07
 **/
@Service
public class UserCommentServiceImpl extends ServiceImpl<UserCommentMapper, UserComment> implements UserCommentService {

    @Autowired
    private  UserCommentMapper  userCommentMapper;

    @Override
    public Page<UserCommentVo> page(UserCommentPageParam userCommentPageParam) {
        Page<UserCommentVo> page=userCommentMapper.selectCommentPid(CommonPageRequest.defaultPage(),userCommentPageParam.getResourceId());
        List<UserCommentVo> list=userCommentMapper.selectCommentNoPid(userCommentPageParam.getResourceId());
        page.getRecords().stream().forEach(item -> {
            List<UserCommentVo> child= list.stream().filter(itemchild-> itemchild.getPid().equals(item.getId())).collect(Collectors.toList());
            item.setChild(child);
            item.setChildSize(child.size());
        });
        return page;
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void add(UserCommentAddParam userCommentAddParam) {
        UserComment userComment = BeanUtil.toBean(userCommentAddParam, UserComment.class);
        userComment.setUserId(StpLoginUserUtil.getLoginUser().getId());
        userComment.setCommentTime(new Date());
        this.save(userComment);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void edit(UserCommentEditParam userCommentEditParam) {
        UserComment userComment = this.queryEntity(userCommentEditParam.getId());
        BeanUtil.copyProperties(userCommentEditParam, userComment);
        userComment.setUserId(StpLoginUserUtil.getLoginUser().getId());
        userComment.setCommentTime(new Date());
        this.updateById(userComment);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void delete(List<UserCommentIdParam> userCommentIdParamList) {
        // 执行删除
        this.removeByIds(CollStreamUtil.toList(userCommentIdParamList, UserCommentIdParam::getId));
    }

    @Override
    public void give(Integer id) {
        UserComment userComment=queryEntity(id);
        if(ObjectUtil.isEmpty(userComment.getGiveNum())) {
            userComment.setGiveNum(1);
        }else{
            userComment.setGiveNum(userComment.getGiveNum()+1);
        }
        this.updateById(userComment);
    }


    public UserComment queryEntity(Integer id) {
        UserComment userComment = this.getById(id);
        if(ObjectUtil.isEmpty(userComment)) {
            throw new CommonException("userComment不存在，id值为：{}", id);
        }
        return userComment;
    }


}
